% make matlab to send data as column vectors
% see: http://www.mathworks.com/matlabcentral/answers/94833-how-can-i-use-in-matlab-a-com-object-that-uses-safearray-string-as-arguments
feature('COM_SafeArraySingleDim', 1)

% get instance of Igor Pro as activeX server (this starts an instance of
% Igor Pro in the background)
igor = actxserver('IgorPro.Application');

% % to catch a running instance of Igor and turn in to an activeX server
% % handle, you can also use: 
% igor = actxGetRunningServer('IgorPro.Application'); % NOTE: Igor must be running!

% make this instance visible
igor.Visible = 1;

% get a handle of Igor's root data folder
root_df = igor.DataFolder('root');

% get handle of waves in Igor's root data folder
igor_waves = root_df.Waves;

% Count waves in Igor's root datafolder
igor_waves.Count

% add the wave tw
nameofwave = 'tw';
ipDateType = 4; % double
npntsx = 8;
npntsy = 0;
npntsz = 0;
npntst = 0;
overwrite = true;
tw = igor_waves.Add(nameofwave,ipDateType,npntsx,npntsy,npntsz,npntst,overwrite);

% Count waves again
igor_waves.Count

% Set data of tw to point number (via Execute)
igor.Execute('tw = p')

% read data back into matlab
tw.GetNumericWaveDataAsDouble

% set data to random values
tw.SetNumericWaveDataAsDouble(randn(npntsx,1))

% check previous operation
tw.GetNumericWaveDataAsDouble

% another option to get a handle (and the data) of tw
igor_waves.Item(0).GetNumericWaveDataAsDouble

% plot tw
igor.Execute('display tw')

% display implementation of all IWaves methods
igor_waves.invoke

% display implementation of all IWave methods
tw.invoke

% Quit Igor and delete activeX server handle
igor.Quit
igor.delete